/**
 * @author Phil Teare
 * using wikipedia data
 */
isoLangs = {
    "ab":{
        "name":"Abkhaz",
        "nativeName":"?????"
    },
    "aa":{
        "name":"Afar",
        "nativeName":"Afaraf"
    },
    "af":{
        "name":"Afrikaans",
        "nativeName":"Afrikaans"
    },
    "ak":{
        "name":"Akan",
        "nativeName":"Akan"
    },
    "sq":{
        "name":"Albanian",
        "nativeName":"Shqip"
    },
    "am":{
        "name":"Amharic",
        "nativeName":"????"
    },
    "ar":{
        "name":"Arabic",
        "nativeName":"???????"
    },
    "an":{
        "name":"Aragonese",
        "nativeName":"Aragons"
    },
    "hy":{
        "name":"Armenian",
        "nativeName":"???????"
    },
    "as":{
        "name":"Assamese",
        "nativeName":"???????"
    },
    "av":{
        "name":"Avaric",
        "nativeName":"???? ????, ???????? ????"
    },
    "ae":{
        "name":"Avestan",
        "nativeName":"avesta"
    },
    "ay":{
        "name":"Aymara",
        "nativeName":"aymar aru"
    },
    "az":{
        "name":"Azerbaijani",
        "nativeName":"az?rbaycan dili"
    },
    "bm":{
        "name":"Bambara",
        "nativeName":"bamanankan"
    },
    "ba":{
        "name":"Bashkir",
        "nativeName":"??????? ????"
    },
    "eu":{
        "name":"Basque",
        "nativeName":"euskara, euskera"
    },
    "be":{
        "name":"Belarusian",
        "nativeName":"??????????"
    },
    "bn":{
        "name":"Bengali",
        "nativeName":"?????"
    },
    "bh":{
        "name":"Bihari",
        "nativeName":"???????"
    },
    "bi":{
        "name":"Bislama",
        "nativeName":"Bislama"
    },
    "bs":{
        "name":"Bosnian",
        "nativeName":"bosanski jezik"
    },
    "br":{
        "name":"Breton",
        "nativeName":"brezhoneg"
    },
    "bg":{
        "name":"Bulgarian",
        "nativeName":"????????? ????"
    },
    "my":{
        "name":"Burmese",
        "nativeName":"?????"
    },
    "ca":{
        "name":"Catalan; Valencian",
        "nativeName":"Catal"
    },
    "ch":{
        "name":"Chamorro",
        "nativeName":"Chamoru"
    },
    "ce":{
        "name":"Chechen",
        "nativeName":"??????? ????"
    },
    "ny":{
        "name":"Chichewa; Chewa; Nyanja",
        "nativeName":"chiChewa, chinyanja"
    },
    "zh":{
        "name":"Chinese",
        "nativeName":"?? (Zhongwn), ??, ??"
    },
    "cv":{
        "name":"Chuvash",
        "nativeName":"????? ?????"
    },
    "kw":{
        "name":"Cornish",
        "nativeName":"Kernewek"
    },
    "co":{
        "name":"Corsican",
        "nativeName":"corsu, lingua corsa"
    },
    "cr":{
        "name":"Cree",
        "nativeName":"???????"
    },
    "hr":{
        "name":"Croatian",
        "nativeName":"hrvatski"
    },
    "cs":{
        "name":"Czech",
        "nativeName":"cesky, cetina"
    },
    "da":{
        "name":"Danish",
        "nativeName":"dansk"
    },
    "dv":{
        "name":"Divehi; Dhivehi; Maldivian;",
        "nativeName":"??????"
    },
    "nl":{
        "name":"Dutch",
        "nativeName":"Nederlands, Vlaams"
    },
    "en":{
        "name":"English",
        "nativeName":"English"
    },
    "eo":{
        "name":"Esperanto",
        "nativeName":"Esperanto"
    },
    "et":{
        "name":"Estonian",
        "nativeName":"eesti, eesti keel"
    },
    "ee":{
        "name":"Ewe",
        "nativeName":"E?egbe"
    },
    "fo":{
        "name":"Faroese",
        "nativeName":"froyskt"
    },
    "fj":{
        "name":"Fijian",
        "nativeName":"vosa Vakaviti"
    },
    "fi":{
        "name":"Finnish",
        "nativeName":"suomi, suomen kieli"
    },
    "fr":{
        "name":"French",
        "nativeName":"franais, langue franaise"
    },
    "ff":{
        "name":"Fula; Fulah; Pulaar; Pular",
        "nativeName":"Fulfulde, Pulaar, Pular"
    },
    "gl":{
        "name":"Galician",
        "nativeName":"Galego"
    },
    "ka":{
        "name":"Georgian",
        "nativeName":"???????"
    },
    "de":{
        "name":"German",
        "nativeName":"Deutsch"
    },
    "el":{
        "name":"Greek, Modern",
        "nativeName":"????????"
    },
    "gn":{
        "name":"Guaran",
        "nativeName":"Avae?"
    },
    "gu":{
        "name":"Gujarati",
        "nativeName":"???????"
    },
    "ht":{
        "name":"Haitian; Haitian Creole",
        "nativeName":"Kreyl ayisyen"
    },
    "ha":{
        "name":"Hausa",
        "nativeName":"Hausa, ??????"
    },
    "he":{
        "name":"Hebrew (modern)",
        "nativeName":"?????"
    },
    "hz":{
        "name":"Herero",
        "nativeName":"Otjiherero"
    },
    "hi":{
        "name":"Hindi",
        "nativeName":"??????, ?????"
    },
    "ho":{
        "name":"Hiri Motu",
        "nativeName":"Hiri Motu"
    },
    "hu":{
        "name":"Hungarian",
        "nativeName":"Magyar"
    },
    "ia":{
        "name":"Interlingua",
        "nativeName":"Interlingua"
    },
    "id":{
        "name":"Indonesian",
        "nativeName":"Bahasa Indonesia"
    },
    "ie":{
        "name":"Interlingue",
        "nativeName":"Originally called Occidental; then Interlingue after WWII"
    },
    "ga":{
        "name":"Irish",
        "nativeName":"Gaeilge"
    },
    "ig":{
        "name":"Igbo",
        "nativeName":"As?s? Igbo"
    },
    "ik":{
        "name":"Inupiaq",
        "nativeName":"Iupiaq, Iupiatun"
    },
    "io":{
        "name":"Ido",
        "nativeName":"Ido"
    },
    "is":{
        "name":"Icelandic",
        "nativeName":"slenska"
    },
    "it":{
        "name":"Italian",
        "nativeName":"Italiano"
    },
    "iu":{
        "name":"Inuktitut",
        "nativeName":"??????"
    },
    "ja":{
        "name":"Japanese",
        "nativeName":"??? (????/?????)"
    },
    "jv":{
        "name":"Javanese",
        "nativeName":"basa Jawa"
    },
    "kl":{
        "name":"Kalaallisut, Greenlandic",
        "nativeName":"kalaallisut, kalaallit oqaasii"
    },
    "kn":{
        "name":"Kannada",
        "nativeName":"?????"
    },
    "kr":{
        "name":"Kanuri",
        "nativeName":"Kanuri"
    },
    "ks":{
        "name":"Kashmiri",
        "nativeName":"???????, ???????"
    },
    "kk":{
        "name":"Kazakh",
        "nativeName":"????? ????"
    },
    "km":{
        "name":"Khmer",
        "nativeName":"?????????"
    },
    "ki":{
        "name":"Kikuyu, Gikuyu",
        "nativeName":"Gikuyu"
    },
    "rw":{
        "name":"Kinyarwanda",
        "nativeName":"Ikinyarwanda"
    },
    "ky":{
        "name":"Kirghiz, Kyrgyz",
        "nativeName":"?????? ????"
    },
    "kv":{
        "name":"Komi",
        "nativeName":"???? ???"
    },
    "kg":{
        "name":"Kongo",
        "nativeName":"KiKongo"
    },
    "ko":{
        "name":"Korean",
        "nativeName":"??? (???), ??? (???)"
    },
    "ku":{
        "name":"Kurdish",
        "nativeName":"Kurd, ??????"
    },
    "kj":{
        "name":"Kwanyama, Kuanyama",
        "nativeName":"Kuanyama"
    },
    "la":{
        "name":"Latin",
        "nativeName":"latine, lingua latina"
    },
    "lb":{
        "name":"Luxembourgish, Letzeburgesch",
        "nativeName":"Ltzebuergesch"
    },
    "lg":{
        "name":"Luganda",
        "nativeName":"Luganda"
    },
    "li":{
        "name":"Limburgish, Limburgan, Limburger",
        "nativeName":"Limburgs"
    },
    "ln":{
        "name":"Lingala",
        "nativeName":"Lingla"
    },
    "lo":{
        "name":"Lao",
        "nativeName":"???????"
    },
    "lt":{
        "name":"Lithuanian",
        "nativeName":"lietuviu kalba"
    },
    "lu":{
        "name":"Luba-Katanga",
        "nativeName":""
    },
    "lv":{
        "name":"Latvian",
        "nativeName":"latvieu valoda"
    },
    "gv":{
        "name":"Manx",
        "nativeName":"Gaelg, Gailck"
    },
    "mk":{
        "name":"Macedonian",
        "nativeName":"?????????? ?????"
    },
    "mg":{
        "name":"Malagasy",
        "nativeName":"Malagasy fiteny"
    },
    "ms":{
        "name":"Malay",
        "nativeName":"bahasa Melayu, ???? ??????"
    },
    "ml":{
        "name":"Malayalam",
        "nativeName":"??????"
    },
    "mt":{
        "name":"Maltese",
        "nativeName":"Malti"
    },
    "mi":{
        "name":"Maori",
        "nativeName":"te reo Maori"
    },
    "mr":{
        "name":"Marathi (Mara?hi)",
        "nativeName":"?????"
    },
    "mh":{
        "name":"Marshallese",
        "nativeName":"Kajin Majel"
    },
    "mn":{
        "name":"Mongolian",
        "nativeName":"??????"
    },
    "na":{
        "name":"Nauru",
        "nativeName":"Ekakairu Naoero"
    },
    "nv":{
        "name":"Navajo, Navaho",
        "nativeName":"Din bizaad, Dink'ehj"
    },
    "nb":{
        "name":"Norwegian Bokml",
        "nativeName":"Norsk bokml"
    },
    "nd":{
        "name":"North Ndebele",
        "nativeName":"isiNdebele"
    },
    "ne":{
        "name":"Nepali",
        "nativeName":"??????"
    },
    "ng":{
        "name":"Ndonga",
        "nativeName":"Owambo"
    },
    "nn":{
        "name":"Norwegian Nynorsk",
        "nativeName":"Norsk nynorsk"
    },
    "no":{
        "name":"Norwegian",
        "nativeName":"Norsk"
    },
    "ii":{
        "name":"Nuosu",
        "nativeName":"??? Nuosuhxop"
    },
    "nr":{
        "name":"South Ndebele",
        "nativeName":"isiNdebele"
    },
    "oc":{
        "name":"Occitan",
        "nativeName":"Occitan"
    },
    "oj":{
        "name":"Ojibwe, Ojibwa",
        "nativeName":"????????"
    },
    "cu":{
        "name":"Old Church Slavonic, Church Slavic, Church Slavonic, Old Bulgarian, Old Slavonic",
        "nativeName":"????? ??????????"
    },
    "om":{
        "name":"Oromo",
        "nativeName":"Afaan Oromoo"
    },
    "or":{
        "name":"Oriya",
        "nativeName":"?????"
    },
    "os":{
        "name":"Ossetian, Ossetic",
        "nativeName":"???? ????"
    },
    "pa":{
        "name":"Panjabi, Punjabi",
        "nativeName":"??????, ???????"
    },
    "pi":{
        "name":"Pali",
        "nativeName":"????"
    },
    "fa":{
        "name":"Persian",
        "nativeName":"?????"
    },
    "pl":{
        "name":"Polish",
        "nativeName":"polski"
    },
    "ps":{
        "name":"Pashto, Pushto",
        "nativeName":"????"
    },
    "pt":{
        "name":"Portuguese",
        "nativeName":"Portugus"
    },
    "qu":{
        "name":"Quechua",
        "nativeName":"Runa Simi, Kichwa"
    },
    "rm":{
        "name":"Romansh",
        "nativeName":"rumantsch grischun"
    },
    "rn":{
        "name":"Kirundi",
        "nativeName":"kiRundi"
    },
    "ro":{
        "name":"Romanian, Moldavian, Moldovan",
        "nativeName":"romna"
    },
    "ru":{
        "name":"Russian",
        "nativeName":"??????? ????"
    },
    "sa":{
        "name":"Sanskrit (Sa?sk?ta)",
        "nativeName":"?????????"
    },
    "sc":{
        "name":"Sardinian",
        "nativeName":"sardu"
    },
    "sd":{
        "name":"Sindhi",
        "nativeName":"??????, ????? ??????"
    },
    "se":{
        "name":"Northern Sami",
        "nativeName":"Davvismegiella"
    },
    "sm":{
        "name":"Samoan",
        "nativeName":"gagana faa Samoa"
    },
    "sg":{
        "name":"Sango",
        "nativeName":"yng t sng"
    },
    "sr":{
        "name":"Serbian",
        "nativeName":"?????? ?????"
    },
    "gd":{
        "name":"Scottish Gaelic; Gaelic",
        "nativeName":"Gidhlig"
    },
    "sn":{
        "name":"Shona",
        "nativeName":"chiShona"
    },
    "si":{
        "name":"Sinhala, Sinhalese",
        "nativeName":"?????"
    },
    "sk":{
        "name":"Slovak",
        "nativeName":"slovencina"
    },
    "sl":{
        "name":"Slovene",
        "nativeName":"slovencina"
    },
    "so":{
        "name":"Somali",
        "nativeName":"Soomaaliga, af Soomaali"
    },
    "st":{
        "name":"Southern Sotho",
        "nativeName":"Sesotho"
    },
    "es":{
        "name":"Spanish; Castilian",
        "nativeName":"espaol, castellano"
    },
    "su":{
        "name":"Sundanese",
        "nativeName":"Basa Sunda"
    },
    "sw":{
        "name":"Swahili",
        "nativeName":"Kiswahili"
    },
    "ss":{
        "name":"Swati",
        "nativeName":"SiSwati"
    },
    "sv":{
        "name":"Swedish",
        "nativeName":"svenska"
    },
    "ta":{
        "name":"Tamil",
        "nativeName":"?????"
    },
    "te":{
        "name":"Telugu",
        "nativeName":"??????"
    },
    "tg":{
        "name":"Tajik",
        "nativeName":"??????, togiki, ???????"
    },
    "th":{
        "name":"Thai",
        "nativeName":"???"
    },
    "ti":{
        "name":"Tigrinya",
        "nativeName":"????"
    },
    "bo":{
        "name":"Tibetan Standard, Tibetan, Central",
        "nativeName":"???????"
    },
    "tk":{
        "name":"Turkmen",
        "nativeName":"Trkmen, ???????"
    },
    "tl":{
        "name":"Tagalog",
        "nativeName":"Wikang Tagalog, ????? ??????"
    },
    "tn":{
        "name":"Tswana",
        "nativeName":"Setswana"
    },
    "to":{
        "name":"Tonga (Tonga Islands)",
        "nativeName":"faka Tonga"
    },
    "tr":{
        "name":"Turkish",
        "nativeName":"Trke"
    },
    "ts":{
        "name":"Tsonga",
        "nativeName":"Xitsonga"
    },
    "tt":{
        "name":"Tatar",
        "nativeName":"???????, tatara, ????????"
    },
    "tw":{
        "name":"Twi",
        "nativeName":"Twi"
    },
    "ty":{
        "name":"Tahitian",
        "nativeName":"Reo Tahiti"
    },
    "ug":{
        "name":"Uighur, Uyghur",
        "nativeName":"Uy?urq?, ?????????"
    },
    "uk":{
        "name":"Ukrainian",
        "nativeName":"??????????"
    },
    "ur":{
        "name":"Urdu",
        "nativeName":"????"
    },
    "uz":{
        "name":"Uzbek",
        "nativeName":"zbek, ?????, ???????"
    },
    "ve":{
        "name":"Venda",
        "nativeName":"Tshiven?a"
    },
    "vi":{
        "name":"Vietnamese",
        "nativeName":"Ti?ng Vi?t"
    },
    "vo":{
        "name":"Volapk",
        "nativeName":"Volapk"
    },
    "wa":{
        "name":"Walloon",
        "nativeName":"Walon"
    },
    "cy":{
        "name":"Welsh",
        "nativeName":"Cymraeg"
    },
    "wo":{
        "name":"Wolof",
        "nativeName":"Wollof"
    },
    "fy":{
        "name":"Western Frisian",
        "nativeName":"Frysk"
    },
    "xh":{
        "name":"Xhosa",
        "nativeName":"isiXhosa"
    },
    "yi":{
        "name":"Yiddish",
        "nativeName":"??????"
    },
    "yo":{
        "name":"Yoruba",
        "nativeName":"Yorb"
    },
    "za":{
        "name":"Zhuang, Chuang",
        "nativeName":"Sa? cue??, Saw cuengh"
    }
}